#include<bits/stdc++.h>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int T,N,M;

    cin >> T;

    for(int i=0; i<T; i++)
    {
        int p=0;

        cin >> N >> M;

        long long* A = new long long[N];
        for(int i=0; i<N; i++)
           cin >> A[i];

        long long* B = new long long[M];
        for(int i=0; i<M; i++)
           cin >> B[i];

        sort(A,A+N);

        long long X = A[1] - A[0];

        for(int i=2; i<N; i++)
           X = __gcd(X,(A[i]-A[i-1]));

        if(X==1)
        {
            cout << 0;
            continue;
        }

        for(int i=0; i<M; i++)
         if(__gcd(X,abs(B[i]-A[0]))==X)
          {
              cout << 0;
              p = 1;
              break;
          }

        if(p==0)
        cout << 1;

    }

    return 0;
}